<?php

namespace Drupal\fieldory;

use Drupal\Component\Plugin\Exception\PluginNotFoundException;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\fieldory\Annotation\Fieldory;

/**
 * Class FieldoryFieldManager.
 *
 * @package Drupal\fieldory
 */
class FieldoryManager extends DefaultPluginManager {

  /**
   * FieldoryManger constructor.
   *
   * @param \Traversable $namespaces
   *   The namespaces.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler.
   */
  public function __construct(\Traversable $namespaces, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/Fieldory', $namespaces, $module_handler, FieldoryInterface::class, Fieldory::class);
  }

  /**
   * Get the field fieldory instance.
   *
   * @param string $id
   *   The fieldory plugin id.
   *
   * @return \Drupal\fieldory\FieldoryBase
   *   A FieldoryBase instance.
   *
   * @throws \Drupal\Component\Plugin\Exception\PluginNotFoundException
   * @throws \Drupal\Component\Plugin\Exception\PluginException
   */
  public function getFieldoryInstance($id) {
    if (!$this->hasDefinition($id)) {
      throw new PluginNotFoundException($id);
    }
    /** @var \Drupal\fieldory\FieldoryBase $instance */
    $instance = $this->createInstance($id);
    return $instance;
  }

}
