<?php

namespace Drupal\fieldory\Plugin\Fieldory;

use Drupal\fieldory\FieldoryBase;
use Drupal\fieldory\MinimalOptionBase;
use Drupal\fieldory\MinimalOptions\StateFieldOption;

/**
 * Class StateField.
 *
 * @Fieldory(
 *     id = "state",
 *     description = "Fieldory for state fields",
 * )
 */
class StateField extends FieldoryBase {

  /**
   * The field type.
   *
   * @var string
   */
  protected $fieldType = 'state';

  /**
   * StateField constructor.
   */
  public function __construct() {
    $this->setFieldFormOptions(['type' => 'options_select']);
    $this->setFieldViewOptions(['type' => 'list_default']);
  }

  /**
   * Set minimal option.
   *
   * @inheritDoc
   */
  public function setMinimalSettings(MinimalOptionBase $option) {
    if ($option instanceof StateFieldOption) {
      $this->setWorkflow($option);
    }
    return $this;
  }

  /**
   * Set the workflow field settings.
   *
   * @param \Drupal\fieldory\MinimalOptions\StateFieldOption $option
   *   The option instance.
   */
  private function setWorkflow(StateFieldOption $option) {
    $this->fieldDefaultValue = $option->defaultValue;
    $this->fieldSettings = [
      'workflow' => $option->workflow,
      'workflow_callback' => '',
    ];

  }

}
