<?php

namespace Drupal\fieldory\Traits;

use Drupal\Core\Language\LanguageInterface;

/**
 * Trait MachineNameTrait.
 *
 * @package Drupal\fieldory\Traits
 */
trait MachineNameTrait {

  /**
   * Get machine name.
   *
   * @param string $value
   *   The input.
   * @param mixed $default
   *   The default value.
   *
   * @return string
   *   The machine name.
   */
  public function getMachineName($value, $default = FALSE) {
    $new_value = \Drupal::transliteration()->transliterate($value, LanguageInterface::LANGCODE_DEFAULT, '_');
    $new_value = strtolower($new_value);
    $new_value = preg_replace('/[^a-z0-9_]+/', '_', $new_value);
    $machine_name = preg_replace('/_+/', '_', $new_value);
    if (empty($machine_name)) {
      return $default;
    }
    return $machine_name;
  }

}
